#include "dcf77.h"

void dcf77_init (void) {
	//Timer init
	TCCR0 = (1<<CS02) | (1<<CS00);	//Pre 1024 -> 0,032768s (3,05 bei '0'; 6,1)
	TIMSK |= (1<<TOIE0);
	//externer Interrupt
	MCUCR = (1<<ISC01) | (1<<ISC00);
	GICR |= (1<<INT0);
}

unsigned char plausibilitaetscheck (	unsigned char std_h_new, unsigned char std_l_new,
										unsigned char min_h_new, unsigned char min_l_new, 
										unsigned char std_h_old, unsigned char std_l_old,
										unsigned char min_h_old, unsigned char min_l_old) {
	unsigned char min_l_old_x = min_l_old;		//Hochzhlen der zuletzt empfangenen Zeit um eine Minute
	unsigned char min_h_old_x = min_h_old;		//Vergleich der hochgezhlten Zeit mit der neu empfangenen
	unsigned char std_l_old_x = std_l_old;		//wenn sie gleich sind, kann Zeit bernommen werden
	unsigned char std_h_old_x = std_h_old;		//sonst wird alte Zeit verworfen und durch neue ersetzt,
													//allerdings wird sie nicht auf die Anzeigen bernommen
	min_l_old_x++;
	if (min_l_old_x == 58) {
		min_l_old_x = '0';
		min_h_old_x++;
		if (min_h_old_x == '6') {
			min_h_old_x = '0';
			std_l_old_x++;
			if (std_l_old_x == 58) {
				std_l_old_x = '0';
				std_h_old_x++;
			}
			if (std_h_old_x == '2'){
				if (std_l_old_x == '4') {
					std_h_old_x = '0';
					std_l_old_x = '0';
				}
			}
		}	
	}
	if (std_h_old_x == std_h_new) {
		if (std_l_old_x == std_l_new) {
			if (min_h_old_x == min_h_new) {
				if (min_l_old_x == min_l_new) {
					return 1;
				}
			}
		}
	}
	return 0;
}

void dcf77_exec (void) {

	unsigned short minute = 0;
	unsigned short stunde = 0;
	unsigned char buffer_std [3] = {0,0,0};
	unsigned char buffer_min [3] = {0,0,0};
	unsigned char parity = 0;
	unsigned char dcf_min_l = '0';
	unsigned char dcf_min_h = '0';
	unsigned char dcf_std_l = '0';
	unsigned char dcf_std_h = '0';
	
	//Stunden
	
	if (dcf_array [29] == '1') {	//stunde 1
		stunde = 1;
		parity++;
	}
	if (dcf_array [30] == '1') {	//stunde 2
		stunde += 2;
		parity++;
	}
	if (dcf_array [31] == '1') {	//stunde 4
		stunde += 4;
		parity++;
	}
	if (dcf_array [32] == '1') {	//stunde 8
		stunde += 8;
		parity++;
	}
	if (dcf_array [33] == '1') {	//stunde 10
		stunde += 10;
		parity++;
	}
	if (dcf_array [34] == '1') {	//stunde 20
		stunde += 20;
		parity++;
	}
	
	if (dcf_array [35] == '1') {	//Prfbit ok ?
		if (parity == 1 || parity == 3 || parity == 5) {
			parity = 0;
		}
		else {
			return;
		}
	}
	else {							//Prfbit ok ?
		if (parity == 0 || parity == 2 || parity == 4 || parity == 6) {
			parity = 0;
		}
		else {
			return;
		}
	}
	
	itoa (stunde, buffer_std, 10);
	
	if (stunde > 9) {
		dcf_std_h = buffer_std [0];
		dcf_std_l = buffer_std [1];
	}
	else {
		dcf_std_h = '0';
		dcf_std_l = buffer_std [0];
	}
	
	//Minuten
	
	if (dcf_array [21] == '1') {	//minute 1
		minute = 1;
		parity++;
	}
	if (dcf_array [22] == '1') {	//minute 2
		minute += 2;
		parity++;
	}
	if (dcf_array [23] == '1') {	//minute 4
		minute += 4;
		parity++;
	}
	if (dcf_array [24] == '1') {	//minute 8
		minute += 8;
		parity++;
	}
	if (dcf_array [25] == '1') {	//minute 10
		minute += 10;
		parity++;
	}
	if (dcf_array [26] == '1') {	//minute 20
		minute += 20;
		parity++;
	}
	if (dcf_array [27] == '1') {	//minute 40
		minute += 40;
		parity++;
	}
	
	if (dcf_array [28] == '1') {	//Prfbit ok ?
		if (parity == 1 || parity == 3 || parity == 5 || parity == 7) {
			parity = 0;
		}
		else {
			return;
		}
	}
	else {							//Prfbit ok ?
		if (parity == 0 || parity == 2 || parity == 4 || parity == 6) {
			parity = 0;
		}
		else {
			return;
		}
	}
	
	itoa (minute, buffer_min, 10);
	
	if (minute > 9) {
		dcf_min_h = buffer_min [0];
		dcf_min_l = buffer_min [1];
	}
	else {
		dcf_min_h = '0';
		dcf_min_l = buffer_min [0];
	}
	
	if (plausibilitaetscheck (	dcf_std_h, dcf_std_l, dcf_min_h, dcf_min_l, 
								dcf_std_h_old, dcf_std_l_old, dcf_min_h_old, dcf_min_l_old)) {
		minuten_l = dcf_min_l;		//wenn der check ok ist, kann Zeit auf Anzeige bernommen werden
		minuten_h = dcf_min_h;
		stunden_l = dcf_std_l;
		stunden_h = dcf_std_h;
		sekunden_h = '0';				//Rcksetzen der Sekunden, da neue Minute gerade erst beginnt
		sekunden_l = '0';
	}
	
	dcf_min_l_old = dcf_min_l;		//sichern der aktuellen Zeitdaten
	dcf_min_h_old = dcf_min_h;
	dcf_std_l_old = dcf_std_l;
	dcf_std_h_old = dcf_std_h;

	
}

SIGNAL (SIG_INTERRUPT0) {			//Beginn eines Zeitsignals
	TCNT0 = 0;						//Rcksetzen des "Auszhltimers"
	dcf_active = 1;
	if (PORTB & (1<<PB3))  			//H-Pegel --> LED aus
		PORTB = ~(1<<PB3) & ~(1<<PB4);
	else
		PORTB = (1<<PB3) | (1<<PB4);	//L-Pegel --> LED an
	GICR &= ~(1<<INT0);			//deaktivieren des externen Interrupts, wenn
}									//Signal komplett, wird er wieder aktiviert

SIGNAL (SIG_OVERFLOW0) {
	if (dcf_active) {
		if (breakcount > 46) {		//Signalpause (58. Bit) ?
			if (array_count >= 58)	//array voll ?
				dcf77_exec ();
			breakcount = 0;
			array_count = 0;
			GICR |= (1<<INT0);		//aktivieren des ext. Int.
			return;
		}	
		breakcount = 0;
		if (PIND & (1<<PD2))		//noch H-Pegel
			timecount++;			//auszhlen des H-Pegels
		else  {						//jetzt L-Pegel
			if (timecount <= 4)
				dcf_array [array_count] = '0';
			if (timecount > 4)
				dcf_array [array_count] = '1';
			array_count++;
			dcf_active = 0;
			timecount = 0;
			GICR |= (1<<INT0);
		}
	}
	else
		breakcount++;				//gerade kein Signal, also auszhlen der Pause
}
