#include "timerfunctions.c"
#include "_7_segment.c"
#include "dcf77.c"

int main (void) {

	_7_segment_init ();						//Initialisierung des MC fr Ansteuerung der 7-Segment-Anzeigen
	time_init ();							//Initialisieren aller zeitrelevanten Fktn
	dcf77_init ();							//Initialisieren der bentigten Resourcen fr DCF77-Empfang
	
	sei ();									//Interrupts global erlauben
	
	for (;;) {
		if (!(PINB & (1<<PB0)))			//Einstellen der Weckzeit
			wake_up ();
		if (wake_enable)					//Alarmton, wenn Alarm aktiviert
			ring_ring ();
		if ((!(PINB & (1<<PB1))) && (!(PINB & (1<<PB2)))) {		//Aktivierung des Alarms
			if (alarm_activate) {
				alarm_activate = 0;
				PORTC |= (1<<PC4);			//Alarm aus -> LED aus
			}
			else {
				alarm_activate = 1;			
				PORTC &= ~(1<<PC4);		//Alarm an -> LED an
			}
			int i = 0;
			for (i=0; i<10; i++)			//Wartezeit, damit Wechsel zwischen Alarm
			delay (65000);					//aktiv bzw. inaktiv nicht zu schnell ist
		}
	}
	return 0;								//wird nie erreicht
}
